/*
 * $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred."
 *
 */
/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident  "@(#)$Header: fpsetmask.c 1.3 89/10/10 $"

#include <ieeefp.h>
#include "fp.h"

#if !i387
fp_except
fpsetmask(newmask)
fp_except newmask;
{
	struct _pcr1167 pcr;
	fp_except oldmask;

	_getpcr(&pcr);
	oldmask = (fp_except)(~pcr.mask & EXCPMASK);
	pcr.mask = ~((unsigned)newmask) & EXCPMASK;
	_putpcr(pcr);
	return oldmask;
}
#else
fp_except
fpsetmask(newmask)
fp_except newmask;
{
	struct _cw87 cw;
	fp_except oldmask;

	_getcw(&cw);
	oldmask = (fp_except)(~cw.mask & EXCPMASK);
	cw.mask = ~((unsigned)newmask) & EXCPMASK;
	_putcw(cw);
	return oldmask;
}
#endif
